Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 4901)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 1)
@@ -1,95 +1,100 @@
-!> @file flow_statistics.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
-! ------------------
-!
+ SUBROUTINE flow_statistics
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
 !
 ! Former revisions:
 ! -----------------
-! $Id$
-! Output ghf and r_a as sum of all horizontally upward-facing surfaces in LSM+USM simulations
-!
-! 4828 2021-01-05 11:21:41Z Giersch
-! Implement relative humidity as diagnostic output quantity
-!
-! 4742 2020-10-14 15:11:02Z schwenkel
-! Implement snow and graupel (bulk microphysics)
-!
-! 4703 2020-09-28 09:21:45Z suehring
-! Revise averaging of land-surface quantities
-!
-! 4672 2020-09-09 21:27:32Z pavelkrc
-! OpenACC bugfix
-!
-! 4671 2020-09-09 20:27:58Z pavelkrc
-! Implementation of downward facing USM and LSM surfaces
-!
-! 4646 2020-08-24 16:02:40Z raasch
-! file re-formatted to follow the PALM coding standard
-!
-! 4581 2020-06-29 08:49:58Z suehring
-! Formatting adjustment
-!
-! 4551 2020-06-02 10:22:25Z suehring
-! Bugfix in summation for statistical regions
-!
-! 4521 2020-05-06 11:39:49Z schwenkel
-! Rename variable
-!
-! 4502 2020-04-17 16:14:16Z schwenkel
-! Implementation of ice microphysics
-!
-! 4472 2020-03-24 12:21:00Z Giersch
-! Calculations of the Kolmogorov lengt scale eta implemented
-!
-! 4464 2020-03-17 11:08:46Z Giersch
-! Reset last change (r4463)
-!
-! 4463 2020-03-17 09:27:36Z Giersch
-! Calculate horizontally averaged profiles of all velocity components at the same place
-!
-! 4444 2020-03-05 15:59:50Z raasch
-! bugfix: cpp-directives for serial mode added
-!
-! 4442 2020-03-04 19:21:13Z suehring
-! Change order of dimension in surface array %frac to allow for better vectorization.
-!
-! 4441 2020-03-04 19:20:35Z suehring
-! Introduction of wall_flags_total_0, which currently sets bits based on static topography
-! information used in wall_flags_static_0
-!
-! 4329 2019-12-10 15:46:36Z motisi
-! Renamed wall_flags_0 to wall_flags_static_0
-!
-! 4182 2019-08-22 15:20:23Z scharf
-! Corrected "Former revisions" section
-!
-! 4131 2019-08-02 11:06:18Z monakurppa
-! Allow profile output for salsa variables.
-!
-! 4039 2019-06-18 10:32:41Z suehring
-! Correct conversion to kinematic scalar fluxes in case of pw-scheme and statistic regions
-!
-! 3828 2019-03-27 19:36:23Z raasch
-! unused variables removed
-!
-! 3676 2019-01-16 15:07:05Z knoop
-! Bugfix, terminate OMP Parallel block
+! $Log: flow_statistics.f90,v $
+! Revision 1.41  2006/08/04 14:37:50  raasch
+! Error removed in non-parallel part (sums_l)
+!
+! Revision 1.40  2006/04/26 14:06:01  raasch
+! Call of omp_get_thread_num written as comment line. Since lcmuk does not
+! understand this comment, a cpp-directive is required.
+!
+! Revision 1.39  2006/04/26 12:19:16  raasch
+! OpenMP optimization, thread number added as third dimension of sums_l,
+! nzb_s_inner(j,i) replaced by nzb in determination of z_i
+!
+! Revision 1.38  2006/02/23 12:23:15  raasch
+! nzb and nzb_diff replaced by nzb_s_outer and nzb_diff_s_outer resrectively,
+! nanz_sums, nanz_2dh, nanz_3d renamed ngp_sums, ngp_2dh and ngp_3d,
+! respectively,
+! ngp_2dh and ngp_3d partially replaced by ngp_2dh_outer and ngp_3d_inner,
+! respectively
+!
+! Revision 1.37  2005/12/06 16:40:21  raasch
+! Calculation of ql (54) profile in case of using cloud droplets
+!
+! Revision 1.36  2005/04/23 09:10:27  raasch
+! +local array sums_ll instead of temporarily using sums_l
+!
+! Revision 1.35  2004/04/30 11:46:56  raasch
+! leap_frog changed to time_integration
+!
+! Revision 1.34  2003/05/09 14:25:12  raasch
+! Parameters in MPI_ALLREDUCE call changed
+!
+! Revision 1.33  2003/03/31 15:42:53  raasch
+! Calculation of horizontal temperature fluxes modified and cleaned up
+!
+! Revision 1.32  2003/03/16 09:39:07  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.31  2003/03/12 16:30:07  raasch
+! Calculation of perturbation and total energy of the total domain
+! re-arranged in order to allow vectorization of the respective loop
+!
+! Revision 1.30  2003/03/04 11:26:35  raasch
+! Error in calculation of the vertical flux of resolved scale energy
+! (profile 57) removed
+!
+! Revision 1.29  2002/12/19 14:50:02  raasch
+! STOP statement replaced by call of subroutine local_stop
+!
+! Revision 1.28  2002/04/16 08:04:19  raasch
+! Error in passive scalar profile (hom(..41..)) removed
+!
+! Revision 1.27  2002/04/11 16:31:03  schroeter
+! No changes.
+!
+! Revision 1.26  2001/09/04  12:00:12  12:00:12  raasch (Siegfried Raasch)
+! Calculation of the vertical flux of resolved scale energy and pressure
+! fluctuations
+! 
+! Revision 1.25  2001/08/21 08:32:24  raasch
+! Special calculation of surface fluxes whenever they are prescribed (not only
+! in case of a Prandtl layer), call of user_interface
+!
+! Revision 1.24  2001/03/30 07:23:34  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.23  2001/02/07 06:48:25  raasch
+! Error in non-parallel passive scalar code removed
+!
+! Revision 1.22  2001/01/29 12:25:02  raasch
+! Passive scalar is considered
+!
+! Revision 1.21  2001/01/22 06:49:27  raasch
+! Module test_variables removed
+!
+! Revision 1.20  2000/04/13 13:54:15  schroeter
+! + computation of new profiles for calculations with
+!   cloud_physics
+!
+! Revision 1.19  2000/01/26  09:32:58  09:32:58  letzel (Marcus Letzel)
+! All comments translated into English
+! 
+! Revision 1.16  1998/04/21 15:54:54  raasch
+! Berechnung von w* beruecksichtigt jetzt den Fall z_i=0,
+! Faktor 0.5 bei Energietransport hinzugefuegt
+!
+! Revision 1.6  1998/02/10 15:06:02  raasch
+! Berechnung des Gesamtwaermestroms, in aufgeloesten Waermestroemen wird das
+! horizontale Temperaturmittel nicht mehr abgezogen, Berechnung der
+! Gesamtimpulsfluesse
 !
 ! Revision 1.1  1997/08/11 06:15:17  raasch
@@ -99,154 +104,43 @@
 ! Description:
 ! ------------
-!> Compute average profiles and further average flow quantities for the different user-defined
-!> (sub-)regions. The region indexed 0 is the total model domain.
-!>
-!> @note For simplicity, nzb_s_inner and nzb_diff_s_inner are used as a lower vertical index for
-!>       k-loops for all variables, although strictly speaking the k-loops would have to be split
-!>       up according to the staggered grid. However, this implies no error since staggered velocity
-!>       components are zero at the walls and inside buildings.
-!> @todo Revise output steering of land-surface and urban-surface output quantities
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE flow_statistics
-
-
-    USE arrays_3d,                                                                                 &
-        ONLY:  ddzu, ddzw, d_exner, e, exner, heatflux_output_conversion, hyp, km, kh,             &
-               momentumflux_output_conversion,                                                     &
-               nc, ni, ng, nr, ns, p, prho, prr, pt, q, qc, qi, qg, ql, qr, qs,                    &
-               rho_air, rho_air_zw, rho_ocean, s, sa, u, ug, v, vg, vpt, w, w_subs,                &
-               waterflux_output_conversion, zw
-
-    USE basic_constants_and_equations_mod,                                                         &
-        ONLY:  g, lv_d_cp, magnus, rd_d_rv
-
-    USE bulk_cloud_model_mod,                                                                      &
-        ONLY: bulk_cloud_model, graupel, snow, microphysics_morrison, microphysics_seifert,        &
-              microphysics_ice_phase
-
-    USE chem_modules,                                                                              &
-        ONLY:  max_pr_cs
-
-    USE control_parameters,                                                                        &
-        ONLY:   air_chemistry, average_count_pr, cloud_droplets, do_sum, dt_3d, humidity,          &
-                initializing_actions, kolmogorov_length_scale, land_surface, large_scale_forcing,  &
-                large_scale_subsidence, max_pr_salsa, max_pr_user, message_string, neutral,        &
-                ocean_mode, passive_scalar, salsa, simulated_time, simulated_time_at_begin,        &
-                urban_surface,                                                                     &
-                use_subsidence_tendencies, use_surface_fluxes, use_top_fluxes, ws_scheme_mom,      &
-                ws_scheme_sca
-
-    USE cpulog,                                                                                    &
-        ONLY:   cpu_log, log_point
-
-    USE grid_variables,                                                                            &
-        ONLY:   ddx, ddy
-
-    USE indices,                                                                                   &
-        ONLY:   ngp_2dh, ngp_2dh_s_inner, ngp_3d, ngp_3d_inner, nxl, nxr, nyn, nys, nzb, nzt,      &
-                topo_min_level, wall_flags_total_0
-
-#if defined( __parallel )
-    USE indices,                                                                                   &
-        ONLY:  ngp_sums, ngp_sums_ls
-#endif
-
-    USE kinds
-
-    USE land_surface_model_mod,                                                                    &
-        ONLY:   m_soil_h, nzb_soil, nzt_soil, t_soil_h
-
-    USE lsf_nudging_mod,                                                                           &
-        ONLY:   td_lsa_lpt, td_lsa_q, td_sub_lpt, td_sub_q, time_vert
-
-    USE module_interface,                                                                          &
-        ONLY:  module_interface_statistics
-
-    USE netcdf_interface,                                                                          &
-        ONLY:  dots_rad, dots_soil, dots_max
-
+! Compute average profiles and further average flow quantities for the different
+! user-defined (sub-)regions. The region indexed 0 is the total model domain.
+!
+! NOTE: For simplicity, nzb_s_outer and nzb_diff_s_outer are being used as a
+! ----  lower vertical index for k-loops for all variables so that regardless
+! of the variable and its respective staggered grid always the same number of
+! grid points is used for 2D averages. The disadvantage: depending on the
+! variable, up to one grid layer adjacent to the (vertical walls of the)
+! topography is missed out by this simplification.
+!------------------------------------------------------------------------------!
+
+    USE arrays_3d
+    USE cloud_parameters
+    USE cpulog
+    USE grid_variables
+    USE indices
+    USE interfaces
     USE pegrid
-
-    USE radiation_model_mod,                                                                       &
-        ONLY:  radiation, radiation_scheme,                                                        &
-               rad_lw_in, rad_lw_out, rad_lw_cs_hr, rad_lw_hr,                                     &
-               rad_sw_in, rad_sw_out, rad_sw_cs_hr, rad_sw_hr
-
     USE statistics
-
-    USE surface_mod,                                                                               &
-        ONLY :  surf_def_h, surf_lsm_h, surf_usm_h
-
+    USE control_parameters
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i                   !<
-    INTEGER(iwp) ::  j                   !<
-    INTEGER(iwp) ::  k                   !<
-    INTEGER(iwp) ::  ki                  !<
-    INTEGER(iwp) ::  k_surface_level     !<
-    INTEGER(iwp) ::  m                   !< loop variable over all horizontal wall elements
-    INTEGER(iwp) ::  l                   !< loop variable over surface facing -- up- or downward-facing
-    INTEGER(iwp) ::  nt                  !<
-!$  INTEGER(iwp) ::  omp_get_thread_num  !<
-    INTEGER(iwp) ::  sr                  !<
-    INTEGER(iwp) ::  tn                  !<
-
-    LOGICAL ::  first  !<
-
-    REAL(wp) ::  dissipation      !< dissipation rate
-    REAL(wp) ::  dptdz_threshold  !<
-    REAL(wp) ::  du_dx            !< Derivative of u fluctuations with respect to x
-    REAL(wp) ::  du_dy            !< Derivative of u fluctuations with respect to y
-    REAL(wp) ::  du_dz            !< Derivative of u fluctuations with respect to z
-    REAL(wp) ::  dv_dx            !< Derivative of v fluctuations with respect to x
-    REAL(wp) ::  dv_dy            !< Derivative of v fluctuations with respect to y
-    REAL(wp) ::  dv_dz            !< Derivative of v fluctuations with respect to z
-    REAL(wp) ::  dw_dx            !< Derivative of w fluctuations with respect to x
-    REAL(wp) ::  dw_dy            !< Derivative of w fluctuations with respect to y
-    REAL(wp) ::  dw_dz            !< Derivative of w fluctuations with respect to z
-    REAL(wp) ::  eta              !< Kolmogorov length scale
-    REAL(wp) ::  fac              !<
-    REAL(wp) ::  flag             !<
-    REAL(wp) ::  height           !<
-    REAL(wp) ::  pts              !<
-    REAL(wp) ::  s11              !< fluctuating rate-of-strain tensor component 11
-    REAL(wp) ::  s21              !< fluctuating rate-of-strain tensor component 21
-    REAL(wp) ::  s31              !< fluctuating rate-of-strain tensor component 31
-    REAL(wp) ::  s12              !< fluctuating rate-of-strain tensor component 12
-    REAL(wp) ::  s22              !< fluctuating rate-of-strain tensor component 22
-    REAL(wp) ::  s32              !< fluctuating rate-of-strain tensor component 32
-    REAL(wp) ::  s13              !< fluctuating rate-of-strain tensor component 13
-    REAL(wp) ::  s23              !< fluctuating rate-of-strain tensor component 23
-    REAL(wp) ::  s33              !< fluctuating rate-of-strain tensor component 33
-    REAL(wp) ::  sums_l_etot      !<
-    REAL(wp) ::  ust              !<
-    REAL(wp) ::  ust2             !<
-    REAL(wp) ::  u2               !<
-    REAL(wp) ::  vst              !<
-    REAL(wp) ::  vst2             !<
-    REAL(wp) ::  v2               !<
-    REAL(wp) ::  w2               !<
-
-    REAL(wp) ::  temp           !< temperature
-    REAL(wp) ::  e_s            !< saturation vapor pressure
-    REAL(wp) ::  q_s            !< saturation mixing ratio
-    REAL(wp) ::  rh_tmp         !< local value of relative humidity
-
-    REAL(wp) ::  dptdz(nzb+1:nzt+1)    !<
-    REAL(wp) ::  sums_ll(nzb:nzt+1,2)  !<
+    INTEGER ::  i, j, k, omp_get_thread_num, sr, tn
+    LOGICAL ::  first
+    REAL    ::  height, pts, sums_l_eper, sums_l_etot, ust, ust2, u2, vst, &
+                vst2, v2, w2, z_i(2)
+    REAL    ::  sums_ll(nzb:nzt+1,2)
 
 
     CALL cpu_log( log_point(10), 'flow_statistics', 'start' )
 
-
-!
-!-- To be on the safe side, check whether flow_statistics has already been called once after the
-!-- current time step.
+!
+!-- To be on the safe side, check whether flow_statistics has already been
+!-- called once after the current time step
     IF ( flow_statistics_called )  THEN
-
-       message_string = 'flow_statistics is called two times within one ' // 'timestep'
-       CALL message( 'flow_statistics', 'PA0190', 1, 2, 0, 6, 0 )
-
+       IF ( myid == 0 )  PRINT*, '+++ WARNING: flow_statistics is called two', &
+                                 ' times within one timestep'
+       CALL local_stop
     ENDIF
 
@@ -257,135 +151,69 @@
 !
 !--    Initialize (local) summation array
-       sums_l = 0.0_wp
-#ifdef _OPENACC
-       !$ACC KERNELS PRESENT(sums_l)
-       sums_l = 0.0_wp
-       !$ACC END KERNELS
+       sums_l = 0.0
+
+!
+!--    Store sums that have been computed in other subroutines in summation
+!--    array
+       sums_l(:,11,:) = sums_l_l(:,sr,:)      ! mixing length from diffusivities
+!--    WARNING: next line still has to be adjusted for OpenMP 
+       sums_l(:,21,0) = sums_wsts_bc_l(:,sr)  ! heat flux from advec_s_bc
+       sums_l(nzb+9,var_sum,0)  = sums_divold_l(sr)  ! old divergence from pres
+       sums_l(nzb+10,var_sum,0) = sums_divnew_l(sr)  ! new divergence from pres
+!--    WARNING: next four lines still may have to be adjusted for OpenMP 
+       sums_l(nzb:nzb+2,var_sum-1,0)    = sums_up_fraction_l(1,1:3,sr)! upstream
+       sums_l(nzb+3:nzb+5,var_sum-1,0)  = sums_up_fraction_l(2,1:3,sr)! parts
+       sums_l(nzb+6:nzb+8,var_sum-1,0)  = sums_up_fraction_l(3,1:3,sr)! from
+       sums_l(nzb+9:nzb+11,var_sum-1,0) = sums_up_fraction_l(4,1:3,sr)! spline
+
+!
+!--    Horizontally averaged profiles of horizontal velocities and temperature.
+!--    They must have been computed before, because they are already required
+!--    for other horizontal averages.
+       tn = 0
+       !$OMP PARALLEL PRIVATE( i, j, k, tn )
+#if defined( __lcmuk )
+       tn = omp_get_thread_num()
+#else
+!$     tn = omp_get_thread_num()
 #endif
 
-!
-!--    Store sums that have been computed in other subroutines in summation array
-       sums_l(:,11,:) = sums_l_l(:,sr,:)      ! mixing length from diffusivities
-!--    WARNING: next line still has to be adjusted for OpenMP
-       sums_l(:,21,0) = sums_wsts_bc_l(:,sr) *                                                     &
-                        heatflux_output_conversion  ! heat flux from advec_s_bc
-       sums_l(nzb+9,pr_palm,0)  = sums_divold_l(sr)  ! old divergence from pres
-       sums_l(nzb+10,pr_palm,0) = sums_divnew_l(sr)  ! new divergence from pres
-
-!
-!--    When calcuating horizontally-averaged total (resolved- plus subgrid-scale) vertical fluxes
-!--    and velocity variances by using commonly-applied Reynolds-based methods
-!--    ( e.g. <w'pt'> = (w-<w>)*(pt-<pt>) ) in combination with the 5th order advection scheme,
-!--    pronounced artificial kinks could be observed in the vertical profiles near the surface.
-!--    Please note: these kinks were not related to the model truth, i.e. these kinks are just
-!--    related to an evaluation problem.
-!--    In order avoid these kinks, vertical fluxes and horizontal as well vertical velocity
-!--    variances are calculated directly within the advection routines, according to the numerical
-!--    discretization, to evaluate the statistical quantities as they will appear within the
-!--    prognostic equations.
-!--    Copy the turbulent quantities, evaluated in the advection routines to the local array
-!--    sums_l() for further computations.
-       IF ( ws_scheme_mom .AND. sr == 0 )  THEN
-
-!
-!--       According to the Neumann bc for the horizontal velocity components, the corresponding
-!--       fluxes has to satisfiy the same bc.
-          IF ( ocean_mode )  THEN
-             sums_us2_ws_l(nzt+1,:) = sums_us2_ws_l(nzt,:)
-             sums_vs2_ws_l(nzt+1,:) = sums_vs2_ws_l(nzt,:)
-          ENDIF
-
-          DO  i = 0, threads_per_task-1
-!
-!--          Swap the turbulent quantities evaluated in advec_ws.
-             sums_l(:,13,i) = sums_wsus_ws_l(:,i) * momentumflux_output_conversion ! w*u*
-             sums_l(:,15,i) = sums_wsvs_ws_l(:,i) * momentumflux_output_conversion ! w*v*
-             sums_l(:,30,i) = sums_us2_ws_l(:,i)                                   ! u*2
-             sums_l(:,31,i) = sums_vs2_ws_l(:,i)                                   ! v*2
-             sums_l(:,32,i) = sums_ws2_ws_l(:,i)                                   ! w*2
-             sums_l(:,34,i) = sums_l(:,34,i) + 0.5_wp *                                            &
-                              ( sums_us2_ws_l(:,i) + sums_vs2_ws_l(:,i) + sums_ws2_ws_l(:,i) )  ! e*
-          ENDDO
-
-       ENDIF
-
-       IF ( ws_scheme_sca .AND. sr == 0 )  THEN
-
-          DO  i = 0, threads_per_task-1
-             sums_l(:,17,i)                        = sums_wspts_ws_l(:,i)                          &
-                                                     * heatflux_output_conversion   ! w*pt*
-             IF ( ocean_mode     ) sums_l(:,66,i)  = sums_wssas_ws_l(:,i)           ! w*sa*
-             IF ( humidity       ) sums_l(:,49,i)  = sums_wsqs_ws_l(:,i)                           &
-                                                     * waterflux_output_conversion  ! w*q*
-             IF ( passive_scalar ) sums_l(:,114,i) = sums_wsss_ws_l(:,i)            ! w*s*
-          ENDDO
-
-       ENDIF
-!
-!--    Horizontally averaged profiles of horizontal velocities and temperature.
-!--    They must have been computed before, because they are already required for other horizontal
-!--    averages.
-       tn = 0
-       !$OMP PARALLEL PRIVATE( i, j, k, tn, flag )
-       !$ tn = omp_get_thread_num()
        !$OMP DO
-       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k, flag) &
-       !$ACC PRESENT(wall_flags_total_0, u, v, pt, rmask, sums_l)
        DO  i = nxl, nxr
           DO  j =  nys, nyn
-             DO  k = nzb, nzt+1
-                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 22 ) )
-                !$ACC ATOMIC
-                sums_l(k,1,tn)  = sums_l(k,1,tn)  + u(k,j,i)  * rmask(j,i,sr) * flag
-                !$ACC ATOMIC
-                sums_l(k,2,tn)  = sums_l(k,2,tn)  + v(k,j,i)  * rmask(j,i,sr) * flag
-                !$ACC ATOMIC
-                sums_l(k,4,tn)  = sums_l(k,4,tn)  + pt(k,j,i) * rmask(j,i,sr) * flag
+             DO  k = nzb_s_outer(j,i), nzt+1
+                sums_l(k,1,tn)  = sums_l(k,1,tn)  + u(k,j,i)  * rmask(j,i,sr)
+                sums_l(k,2,tn)  = sums_l(k,2,tn)  + v(k,j,i)  * rmask(j,i,sr)
+                sums_l(k,4,tn)  = sums_l(k,4,tn)  + pt(k,j,i) * rmask(j,i,sr)
              ENDDO
           ENDDO
        ENDDO
-       !$ACC UPDATE HOST(sums_l(:,1,tn), sums_l(:,2,tn), sums_l(:,4,tn))
-
-!
-!--    Horizontally averaged profile of salinity
-       IF ( ocean_mode )  THEN
+
+!
+!--    Horizontally averaged profiles of virtual potential temperature,
+!--    total water content, specific humidity and liquid water potential
+!--    temperature
+       IF ( moisture )  THEN
           !$OMP DO
           DO  i = nxl, nxr
              DO  j =  nys, nyn
-                DO  k = nzb, nzt+1
-                   sums_l(k,23,tn)  = sums_l(k,23,tn) + sa(k,j,i)                                  &
-                                      * rmask(j,i,sr)                                              &
-                                      * MERGE( 1.0_wp, 0.0_wp,                                     &
-                                               BTEST( wall_flags_total_0(k,j,i), 22 ) )
+                DO  k = nzb_s_outer(j,i), nzt+1
+                   sums_l(k,44,tn)  = sums_l(k,44,tn) + &
+                                      vpt(k,j,i) * rmask(j,i,sr)
+                   sums_l(k,41,tn)  = sums_l(k,41,tn) + &
+                                      q(k,j,i) * rmask(j,i,sr)
                 ENDDO
              ENDDO
           ENDDO
-       ENDIF
-
-!
-!--    Horizontally averaged profiles of virtual potential temperature, total water content, water
-!--    vapor mixing ratio and liquid water potential temperature
-       IF ( humidity )  THEN
-          !$OMP DO
-          DO  i = nxl, nxr
-             DO  j =  nys, nyn
-                DO  k = nzb, nzt+1
-                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 22 ) )
-                   sums_l(k,44,tn)  = sums_l(k,44,tn) + vpt(k,j,i) * rmask(j,i,sr) * flag
-                   sums_l(k,41,tn)  = sums_l(k,41,tn) + q(k,j,i) * rmask(j,i,sr)   * flag
-                ENDDO
-             ENDDO
-          ENDDO
-          IF ( bulk_cloud_model )  THEN
+          IF ( cloud_physics )  THEN
              !$OMP DO
              DO  i = nxl, nxr
                 DO  j =  nys, nyn
-                   DO  k = nzb, nzt+1
-                      flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 22 ) )
-                      sums_l(k,42,tn) = sums_l(k,42,tn) +                      &
-                                        ( q(k,j,i) - ql(k,j,i) ) * rmask(j,i,sr) * flag
-                      sums_l(k,43,tn) = sums_l(k,43,tn) + (                                        &
-                                           pt(k,j,i) + lv_d_cp * d_exner(k) * ql(k,j,i)            &
-                                                          ) * rmask(j,i,sr) * flag
+                   DO  k = nzb_s_outer(j,i), nzt+1
+                      sums_l(k,42,tn) = sums_l(k,42,tn) + &
+                                      ( q(k,j,i) - ql(k,j,i) ) * rmask(j,i,sr)
+                      sums_l(k,43,tn) = sums_l(k,43,tn) + ( &
+                                      pt(k,j,i) + l_d_cp*pt_d_t(k) * ql(k,j,i) &
+                                                          ) * rmask(j,i,sr)
                    ENDDO
                 ENDDO
@@ -400,9 +228,6 @@
           DO  i = nxl, nxr
              DO  j =  nys, nyn
-                DO  k = nzb, nzt+1
-                   sums_l(k,115,tn)  = sums_l(k,115,tn) + s(k,j,i)                                 &
-                                       * rmask(j,i,sr)                                             &
-                                       * MERGE( 1.0_wp, 0.0_wp,                                    &
-                                                BTEST( wall_flags_total_0(k,j,i), 22 ) )
+                DO  k = nzb_s_outer(j,i), nzt+1
+                   sums_l(k,41,tn)  = sums_l(k,41,tn) + q(k,j,i) * rmask(j,i,sr)
                 ENDDO
              ENDDO
@@ -410,4 +235,5 @@
        ENDIF
        !$OMP END PARALLEL
+
 !
 !--    Summation of thread sums
@@ -417,11 +243,8 @@
              sums_l(:,2,0) = sums_l(:,2,0) + sums_l(:,2,i)
              sums_l(:,4,0) = sums_l(:,4,0) + sums_l(:,4,i)
-             IF ( ocean_mode )  THEN
-                sums_l(:,23,0) = sums_l(:,23,0) + sums_l(:,23,i)
-             ENDIF
-             IF ( humidity )  THEN
+             IF ( moisture )  THEN
                 sums_l(:,41,0) = sums_l(:,41,0) + sums_l(:,41,i)
                 sums_l(:,44,0) = sums_l(:,44,0) + sums_l(:,44,i)
-                IF ( bulk_cloud_model )  THEN
+                IF ( cloud_physics )  THEN
                    sums_l(:,42,0) = sums_l(:,42,0) + sums_l(:,42,i)
                    sums_l(:,43,0) = sums_l(:,43,0) + sums_l(:,43,i)
@@ -429,5 +252,5 @@
              ENDIF
              IF ( passive_scalar )  THEN
-                sums_l(:,115,0) = sums_l(:,115,0) + sums_l(:,115,i)
+                sums_l(:,41,0) = sums_l(:,41,0) + sums_l(:,41,i)
              ENDIF
           ENDDO
@@ -437,39 +260,26 @@
 !
 !--    Compute total sum from local sums
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( sums_l(nzb,1,0), sums(nzb,1), nzt+2-nzb, MPI_REAL, MPI_SUM, comm2d,     &
-                           ierr )
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( sums_l(nzb,2,0), sums(nzb,2), nzt+2-nzb, MPI_REAL, MPI_SUM, comm2d,     &
-                           ierr )
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( sums_l(nzb,4,0), sums(nzb,4), nzt+2-nzb, MPI_REAL, MPI_SUM, comm2d,     &
-                           ierr )
-       IF ( ocean_mode )  THEN
-          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-          CALL MPI_ALLREDUCE( sums_l(nzb,23,0), sums(nzb,23), nzt+2-nzb, MPI_REAL, MPI_SUM, comm2d,&
-                              ierr )
-       ENDIF
-       IF ( humidity ) THEN
-          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-          CALL MPI_ALLREDUCE( sums_l(nzb,44,0), sums(nzb,44), nzt+2-nzb, MPI_REAL, MPI_SUM, comm2d,&
-                              ierr )
-          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-          CALL MPI_ALLREDUCE( sums_l(nzb,41,0), sums(nzb,41), nzt+2-nzb, MPI_REAL, MPI_SUM, comm2d,&
-                              ierr )
-          IF ( bulk_cloud_model ) THEN
-             IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-             CALL MPI_ALLREDUCE( sums_l(nzb,42,0), sums(nzb,42), nzt+2-nzb, MPI_REAL, MPI_SUM,     &
-                                 comm2d, ierr )
-             IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-             CALL MPI_ALLREDUCE( sums_l(nzb,43,0), sums(nzb,43), nzt+2-nzb, MPI_REAL, MPI_SUM,     &
-                                 comm2d, ierr )
+       CALL MPI_ALLREDUCE( sums_l(nzb,1,0), sums(nzb,1), nzt+2-nzb, MPI_REAL, &
+                           MPI_SUM, comm2d, ierr )
+       CALL MPI_ALLREDUCE( sums_l(nzb,2,0), sums(nzb,2), nzt+2-nzb, MPI_REAL, &
+                           MPI_SUM, comm2d, ierr )
+       CALL MPI_ALLREDUCE( sums_l(nzb,4,0), sums(nzb,4), nzt+2-nzb, MPI_REAL, &
+                           MPI_SUM, comm2d, ierr )
+       IF ( moisture ) THEN
+          CALL MPI_ALLREDUCE( sums_l(nzb,44,0), sums(nzb,44), nzt+2-nzb, &
+                              MPI_REAL, MPI_SUM, comm2d, ierr )
+          CALL MPI_ALLREDUCE( sums_l(nzb,41,0), sums(nzb,41), nzt+2-nzb, &
+                              MPI_REAL, MPI_SUM, comm2d, ierr )
+          IF ( cloud_physics ) THEN
+             CALL MPI_ALLREDUCE( sums_l(nzb,42,0), sums(nzb,42), nzt+2-nzb, &
+                                 MPI_REAL, MPI_SUM, comm2d, ierr )
+             CALL MPI_ALLREDUCE( sums_l(nzb,43,0), sums(nzb,43), nzt+2-nzb, &
+                                 MPI_REAL, MPI_SUM, comm2d, ierr )
           ENDIF
        ENDIF
 
        IF ( passive_scalar )  THEN
-          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-          CALL MPI_ALLREDUCE( sums_l(nzb,115,0), sums(nzb,115), nzt+2-nzb, MPI_REAL, MPI_SUM,      &
-                              comm2d, ierr )
+          CALL MPI_ALLREDUCE( sums_l(nzb,41,0), sums(nzb,41), nzt+2-nzb, &
+                              MPI_REAL, MPI_SUM, comm2d, ierr )
        ENDIF
 #else
